#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <dhooks>


new Handle:g_hProcessVoice = INVALID_HANDLE;
new g_iHookID[MAXPLAYERS+1] = { -1, ... };

public OnPluginStart()
{
	new offset = GameConfGetOffset(GetConfig(), "CGameClient::ProcessVoiceData");
	
	g_hProcessVoice = DHookCreate(offset, HookType_Raw, ReturnType_Void, ThisPointer_Address, Hook_ProcessVoiceData);
	DHookAddParam(g_hProcessVoice, HookParamType_ObjectPtr);
}

public OnClientPutInServer(client)
{
	if (!IsFakeClient(client))
	{
		g_iHookID[client] = DHookRaw(g_hProcessVoice, true, GetIMsgHandler(client));
	}
}

public OnClientDisconnect(client)
{
	if (g_iHookID[client] != -1)
	{
		DHookRemoveHookID(g_iHookID[client]);
		
		g_iHookID[client] = -1;
	}
}

public MRESReturn:Hook_ProcessVoiceData(Address:this, Handle:hParams)
{
	new Address:pIClient = this - Address:4;
	new client = GetPlayerSlot(pIClient) + 1;
	
//	PrintToServer("%N (%i) is speaking!", client, client);

	PrintToChat(client, "%N (%i) is speaking!", client, client);
	
	return MRES_Ignored;
}

/*
* Internal Functions
*/
stock Handle:GetConfig()
{
	static Handle:hGameConf = INVALID_HANDLE;
	
	if (hGameConf == INVALID_HANDLE)
	{
		hGameConf = LoadGameConfigFile("voiceannounce.games");
	}
	
	return hGameConf;
}

stock Address:GetBaseServer()
{
	static Address:pBaseServer = Address_Null;
	
	if (pBaseServer == Address_Null)
	{
		pBaseServer = GameConfGetAddress(GetConfig(), "CBaseServer");
	}
	
	return pBaseServer;
}

stock Address:GetIClient(slot)
{
	static Handle:hGetClient = INVALID_HANDLE;
	
	if (hGetClient == INVALID_HANDLE)
	{
		StartPrepSDKCall(SDKCall_Raw);
		PrepSDKCall_SetFromConf(GetConfig(), SDKConf_Virtual, "CBaseServer::GetClient");
		PrepSDKCall_SetReturnInfo(SDKType_PlainOldData, SDKPass_Plain);
		PrepSDKCall_AddParameter(SDKType_PlainOldData, SDKPass_Plain);
		hGetClient = EndPrepSDKCall();
	}
	
	return Address:SDKCall(hGetClient, GetBaseServer(), slot);
}

stock GetPlayerSlot(Address:pIClient)
{
	static Handle:hPlayerSlot = INVALID_HANDLE;
	
	if (hPlayerSlot == INVALID_HANDLE)
	{
		StartPrepSDKCall(SDKCall_Raw);
		PrepSDKCall_SetFromConf(GetConfig(), SDKConf_Virtual, "CBaseClient::GetPlayerSlot");
		PrepSDKCall_SetReturnInfo(SDKType_PlainOldData, SDKPass_Plain);
		hPlayerSlot = EndPrepSDKCall();
	}
	
	return SDKCall(hPlayerSlot, pIClient);
}

stock Address:GetIMsgHandler(client)
{
	return GetIClient(client - 1) + Address:4;
}
